%Assignment:
%Write a Matlab program that creates a simple movie
%Hao Huy Tran, haotrani@temple.edu, Oct. 4, 2002
%
% input: none  Ex: SimpleMovie;
% output: an avifile "rollingball.avi"

function [aviFileName] = SimpleMovie

%Loade ballinhall.bmp into mpicture matrix
mpicture = imread('ballinhall.bmp');

% Set parameters for new AVI file
framesPerSec = 5;
aviFileName = 'rollingball';

%Create a new AVI file
aviobj = avifile(aviFileName,'fps',framesPerSec,'COMPRESSION','RLE');

%Movie gets the first frame
frameObj = im2frame(mpicture, gray(256));
aviobj = addframe(aviobj,frameObj);

%Create 192 movie frames 
for i=2:193
    moveup = -5;
    moveright = 5; 
    movedown = 5;
    moveleft = -5;

    %Find the location of the ball the image matrix
    [ballRows,ballCols] = find(mpicture == 0);
    
    %Clear the ball from the image
    for j=1:size(ballRows,1)
        mpicture(ballRows(j),ballCols(j)) = 255;
    end
    
    %The old coordinates of the ball in the image are translated to new location
    if i <= 52
        newballRows = ballRows + moveup;
        newballCols = ballCols;
    elseif i > 52 & i <= 102
        newballRows = ballRows;
        newballCols = ballCols + moveright;
    elseif i > 102 & i <= 152
       newballRows = ballRows + movedown;
       newballCols = ballCols; 
    else
       newballRows = ballRows;
       newballCols = ballCols + moveleft;
    end
    
    %Paint the ball into the image at new location
    for k=1:size(newballRows,1)
        mpicture(newballRows(k),newballCols(k)) = 0;
    end
    
    %Movie gets the next frame from the  image
    frameObj = im2frame(mpicture, gray(256));  
    aviobj = addframe(aviobj,frameObj);
    
end
aviobj = close(aviobj);
return;